import { browser, ExpectedConditions as ec /* , promise */ } from 'protractor';
import { NavBarPage, SignInPage } from '../../page-objects/jhi-page-objects';

import {
  SavedSearchesComponentsPage,
  /* SavedSearchesDeleteDialog, */
  SavedSearchesUpdatePage,
} from './saved-searches.page-object';

const expect = chai.expect;

describe('SavedSearches e2e test', () => {
  let navBarPage: NavBarPage;
  let signInPage: SignInPage;
  let savedSearchesComponentsPage: SavedSearchesComponentsPage;
  let savedSearchesUpdatePage: SavedSearchesUpdatePage;
  /* let savedSearchesDeleteDialog: SavedSearchesDeleteDialog; */
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  const username = process.env.E2E_USERNAME ?? 'admin';
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  const password = process.env.E2E_PASSWORD ?? 'search@admin';

  before(async () => {
    await browser.get('/');
    await browser.sleep(2000);
    navBarPage = new NavBarPage();
    signInPage = await navBarPage.getSignInPage();
    await signInPage.autoSignInUsing(username, password);
    await browser.wait(ec.visibilityOf(navBarPage.entityMenu), 5000);
    // await navBarPage.clickOnEntityMenu();
  });

  it('should load SavedSearches', async () => {
    await navBarPage.goToEntity('saved-searches');
    savedSearchesComponentsPage = new SavedSearchesComponentsPage();
    await browser.wait(ec.visibilityOf(savedSearchesComponentsPage.title), 5000);
    expect(await savedSearchesComponentsPage.getTitle()).to.eq('gitsearchApp.savedSearches.home.title');
    await browser.wait(
      ec.or(ec.visibilityOf(savedSearchesComponentsPage.entities), ec.visibilityOf(savedSearchesComponentsPage.noResult)),
      1000
    );
  });

  it('should load create SavedSearches page', async () => {
    await savedSearchesComponentsPage.clickOnCreateButton();
    savedSearchesUpdatePage = new SavedSearchesUpdatePage();
    expect(await savedSearchesUpdatePage.getPageTitle()).to.eq('gitsearchApp.savedSearches.home.createOrEditLabel');
    await savedSearchesUpdatePage.cancel();
  });

  after(async () => {
    await navBarPage.autoSignOut();
  });
});
