import { browser, ExpectedConditions as ec /* , promise */ } from 'protractor';
import { NavBarPage, SignInPage } from '../../page-objects/jhi-page-objects';

import {
  UserWatchListComponentsPage,
  /* UserWatchListDeleteDialog, */
  UserWatchListUpdatePage,
} from './user-watch-list.page-object';

const expect = chai.expect;

describe('UserWatchList e2e test', () => {
  let navBarPage: NavBarPage;
  let signInPage: SignInPage;
  let userWatchListComponentsPage: UserWatchListComponentsPage;
  let userWatchListUpdatePage: UserWatchListUpdatePage;
  const username = process.env.E2E_USERNAME ?? 'admin';
  const password = process.env.E2E_PASSWORD ?? 'search@admin';

  before(async () => {
    await browser.get('/');
    await browser.sleep(2000);
    navBarPage = new NavBarPage();
    signInPage = await navBarPage.getSignInPage();
    await signInPage.autoSignInUsing(username, password);
    await browser.wait(ec.visibilityOf(navBarPage.entityMenu), 5000);
  });

  it('should load UserWatchLists', async () => {
    await navBarPage.goToEntity('user-watch-list');
    userWatchListComponentsPage = new UserWatchListComponentsPage();
    await browser.wait(ec.visibilityOf(userWatchListComponentsPage.title), 5000);
    expect(await userWatchListComponentsPage.getTitle()).to.eq('gitsearchApp.userWatchList.home.title');
    await browser.wait(
      ec.or(ec.visibilityOf(userWatchListComponentsPage.entities), ec.visibilityOf(userWatchListComponentsPage.noResult)),
      1000
    );
  });

  it('should load create UserWatchList page', async () => {
    await userWatchListComponentsPage.clickOnCreateButton();
    userWatchListUpdatePage = new UserWatchListUpdatePage();
    expect(await userWatchListUpdatePage.getPageTitle()).to.eq('gitsearchApp.userWatchList.home.createOrEditLabel');
    await userWatchListUpdatePage.cancel();
  });

  after(async () => {
    await navBarPage.autoSignOut();
  });
});
